require 'rake'
require 'branchable_cdn_assets-middleman'
require 'branchable_cdn_assets/rake_tasks'

module BranchableCDNAssets
  module Middleman

    class RakeTasks < BranchableCDNAssets::RakeTasks

      class << self
        def register namespace=:cdn
          RakeTasks.new( namespace ).register_tasks
        end
      end

      def initialize namespace
        @rake_namespace = namespace
      end

      def mm
        @_mm ||= ::Middleman::Application.server.inst
      end

      def file_manager
        return @_file_manager if @_file_manager

        inst = mm.extensions[:cdn_assets].values.find { |inst| inst.id.to_s == @rake_namespace.to_s }
        @_file_manager = FileManager.new inst.config

        return @_file_manager
      end

    end

  end
end